//+------------------------------------------------------------------+
//|                              StopLoss and TakeProfit Manager.mq4 |
//|                              Copyright  2009, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TradingSytemForex"
#property link "http://www.tradingsystemforex.com"

#include <stderror.mqh>
#include <stdlib.mqh>

extern int StopLoss=000;
extern int TakeProfit=30;
extern bool Use_Traling_Stop = false ;
extern int Trailing_Stop = 10;

//+------------------------- Traling stop -----------------------------+

// Header files for the errors description :

#include <stderror.mqh>
#include <stdlib.mqh>

//----------------------

void Check_Modify_For_TS(int Check_Number) // Check order modify
{
   if(Check_Number<0)Print("OrderModify according traling stop failed with error: ", ErrorDescription(GetLastError()));
      else Print("Order Modified successfully according traling stop system");
}

//----------------------

double Last_Profit_Array [ 1000 ] ;

//----

void Last_Profit_Point ( int Order_Pos )
{    
    if ( OrderSelect ( Order_Pos , SELECT_BY_POS , MODE_TRADES ) == true )
    
      if ( Last_Profit_Array [ Order_Pos ] == 0 )
      
         Last_Profit_Array [ Order_Pos ] = OrderProfit ( ) / OrderLots ( ) ;
}

//----------------------

/*

Trailing_Stop_Function :


Trailing_Stop_value :  Traling stop value in pips, put 0 to disable the traling stop system

Order_Magic_Number : put 0 for ignore it and work with all orders

*/

void Trailing_Stop_Function ( int Trailing_Stop_value , int Order_Magic_Number )
{   
   int loop = 0 ;
   
   for ( int i = 0 ; loop < OrdersTotal ( ) ; i++ ) 
   
      if ( OrderSelect ( i , SELECT_BY_POS , MODE_TRADES ) == true )
      {
            loop++ ;
            
            if ( OrderSymbol( ) == Symbol( ) )
            
            if ( OrderMagicNumber ( ) == Order_Magic_Number || Order_Magic_Number == 0 )
            
            if ( Trailing_Stop_value != 0 )
            {
               Last_Profit_Point ( i ) ;
               
               if ( OrderType ( ) == OP_BUY )
               {
                  double Buy_Stop_Loss ;
                  
                  if ( OrderStopLoss ( ) == 0 ) Buy_Stop_Loss = Ask - ( Trailing_Stop_value * Point ( ) ) ;
                  
                  else Buy_Stop_Loss = OrderStopLoss ( ) ;
                  
                  double Buy_Step = ( OrderProfit ( ) / OrderLots ( ) ) - Last_Profit_Array [ i ] ;
                  
                  if ( Buy_Step >= Trailing_Stop_value * Point ( )  )
                  {   
                     Check_Modify_For_TS ( OrderModify ( OrderTicket ( ) , OrderOpenPrice ( ) , Buy_Stop_Loss + ( Buy_Step * Point ( ) ) , OrderTakeProfit ( ) , 0 , White ) ) ;
                     
                     Last_Profit_Array [ i ] = OrderProfit ( ) / OrderLots ( ) ;
                  }
               }
               
               else
               
               if ( OrderType ( ) == OP_SELL )
               {
                  double Sell_Stop_Loss ;
                  
                  if ( OrderStopLoss ( ) == 0 ) Sell_Stop_Loss = Bid + ( Trailing_Stop_value * Point ( ) ) ;
                  
                  else Sell_Stop_Loss = OrderStopLoss ( ) ;
                  
                  double Sell_Step = ( OrderProfit ( ) / OrderLots ( ) ) - Last_Profit_Array [ i ] ;
                  
                  if ( Sell_Step >= Trailing_Stop_value * Point ( )  )
                  {   
                     Check_Modify_For_TS ( OrderModify ( OrderTicket ( ) , OrderOpenPrice ( ) , Sell_Stop_Loss - ( Sell_Step * Point ( ) ) , OrderTakeProfit ( ) , 0 , White ) ) ;
                     
                     Last_Profit_Array [ i ] = OrderProfit ( ) / OrderLots ( ) ;
                  }
               }
               
            } 
            
        }
}

//+-------------------------  Traling stop end  ----------------------+


void Check_Modify(int Check_Number) // Check order modify
{
   if(Check_Number<0)Print("OrderModify failed with error: ", ErrorDescription(GetLastError()));
      else Print("Order Modified successfully");
}

//+------------------------------------------------------------------+

void OnTick ( ) 
{  
   double SL,TP;
   int i,Total;
   int Dig=MarketInfo(Symbol(),MODE_DIGITS);     

//-------

  Total=OrdersTotal();
  if(Total>0)
  {
     for(i=Total-1; i>=0; i--) 
     {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true) 
        {
           if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderStopLoss()==0 && OrderTakeProfit()==0 ) 
           {
              if(StopLoss>0)SL=OrderOpenPrice()+StopLoss*Point;else SL=0;
              if(TakeProfit>0)TP=OrderOpenPrice()-TakeProfit*Point;else TP=0;
            
              Check_Modify ( OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,Dig),NormalizeDouble(TP,Dig),OrderExpiration(),CLR_NONE) ) ;
           }
           if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderStopLoss()==0 && OrderTakeProfit()==0 ) 
           {
              if(StopLoss>0)SL=OrderOpenPrice()-StopLoss*Point;else SL=0;
              if(TakeProfit>0)TP=OrderOpenPrice()+TakeProfit*Point;else TP=0;
              
              Check_Modify ( OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,Dig),NormalizeDouble(TP,Dig),OrderExpiration(),CLR_NONE) ) ;
           }
        }
     }
  }
  
//-------

   if ( Use_Traling_Stop == true )
      Trailing_Stop_Function ( Trailing_Stop  , 0 ) ;

}
